image: registry.gitlab.com/studevsoc/sumedha/flutter-fastlane-ci-cd-image:latest
stages:
  - test
  - update
  - build
  - deploy

tests:
  stage: test
  only:
    - master
  tags:
    - ruby
  script:
    - bundle install
    - flutter test
  interruptible: true

update:
  stage: update
  only:
    - master
  tags:
    - ruby
  script:
    - flutter packages get
    - flutter packages upgrade
  interruptible: true

android:build:
  stage: build
  tags:
    - ruby
  script:
    # Flutter local configuration
    - mkdir ~/keys
    - mkdir ~/keys/android
    - bundle install
    - ruby get_keys.rb
    - which flutter
    - echo flutter.sdk=$FLUTTER_PATH > android/local.properties
    - echo sdk.dir=$ANDROID_SDK_PATH >> android/local.properties
    - echo flutter.buildMode=release >> android/local.properties
    # Android signing
    - echo storePassword=$ANDROID_KEY_STORE_PASSWORD > android/key.properties
    - echo keyPassword=$ANDROID_KEY_PASSWORD >> android/key.properties
    - echo keyAlias=$ANDROID_KEY_ALIAS >> android/key.properties
    - echo storeFile=$ANDROID_KEYSTORE_PATH >> android/key.properties
    # release memory
    - killall java || true
    - cd android
    - bundle install
    - bundle exec fastlane build_android production:true
    - rm -f android/local.properties
    - rm -f android/key.properties
    - rm -rf ~/keys
    # release memory
    - killall java || true
  artifacts:
    paths:
    - build/app/outputs/apk/release/app-release.apk
    - build/app/outputs/bundle/release/app-release.aab
    expire_in: 1 week
  interruptible: true

ios:build:
  stage: build
  tags:
    - ruby
  script:
    - cd ios
#    - export TEMP_KEYCHAIN_NAME=fastlane_$(cat /dev/urandom | LC_ALL=C tr -dc 'a-zA-Z0-9' | fold -w ${1:-16} | head -n 1)
#    - export TEMP_KEYCHAIN_PASSWORD=$(cat /dev/urandom | LC_ALL=C tr -dc 'a-zA-Z0-9' | fold -w ${1:-64} | head -n 1)
#    - bundle exec fastlane build_ios
  artifacts:
    paths:
    - ios/Runner.ipa
    expire_in: 1 week
  interruptible: true

prod:android:deploy:
  stage: deploy
  tags:
    - ruby
  script:
    # release memory
    - killall java || true
    - cd android
    - bundle exec fastlane android deploy_android production:true
    - killall java || true
  when: manual
  dependencies:
    - android:build

prod:ios:deploy:
  stage: deploy
  tags:
    - sumedha
  script:
    - cd ios
#    - bundle exec fastlane deploy_ios
  when: manual
  dependencies:
    - ios:build

z:internal:android:deploy:
  stage: deploy
  tags:
    - ruby
  script:
    # release memory
    - mkdir ~/keys
    - mkdir ~/keys/android
    - bundle install
    - ruby get_keys.rb
    - killall java || true
    - cd android
    - bundle install
    - bundle exec fastlane android deploy_android internal:true
    - killall java || true
    - rm -rf ~/keys
  when: manual
  dependencies:
    - android:build

z:tflight:ios:deploy:
  stage: deploy
  tags:
    - ruby
  script:
    - cd ios
#    - bundle exec fastlane deploy_ios testflight:true
  when: manual
  dependencies:
    - android:build

